﻿"use strict";

/*
 * Simple proxy script that redirects incoming messages
 * to FotoWare through an iframe. Message replies are
 * redirected back to caller.
 */

document.addEventListener('DOMContentLoaded',
    function (event) {

        //debugger 
        //check cookie! 
        var cookiename = getQueryStringParameterByName('cn');
        var accesstoken = getCookie(cookiename);

        if (accesstoken === "") {
                //need to refresh accesstoken
                //todo some  kind of loader "logging in" use fotoware loader
                ajax("../../../authentication/refresh?refreshtoken=true",
                    function (xhttp) {
                        
                        if (xhttp.responseText === "login") {
                            document.location.href = "../../../authentication/login";
                            return;
                        }
                        else
                            document.location.reload();//success
                    },
                    function() {
                        //not working, go do login
                        document.location.href = "../../../authentication/login";
                        return;
                });
                //stop loader
            return;//stop!
        }


        // Input commands to FotoWare:
        //
        // init:    initialize communication
        // ping:    keep connection alive
        const incomingCommands = ['init', 'ping'];

        const iframe = document.getElementById('mainframe');

        // get origin/URL from query string
        var ivOrigin = getQueryStringParameterByName('fotowareBaseUrl');
        var i = getQueryStringParameterByName('i');

        if (i!=="") {//going to export widget
            i = "?i=" + i;
            i += "&pub=" + document.location.origin;
            i += "&" + window.location.href.substr(window.location.href.indexOf("pass=true&"),
                    window.location.href.length - window.location.href.indexOf("pass=true&") + 11);
            i +="&access_token=" + accesstoken;
        }
        //debugger;
        // if no fotowareBaseUrl, use default 'error.html'
        if (!ivOrigin || ivOrigin.length == 0) {

            ivOrigin = 'error.html';
        }

        // set iframe to FotoWare origin with query string
        iframe.src = ivOrigin + i + "#access_token=" + accesstoken;

        // Make sure target origin does not have trailing slash
        if (ivOrigin.slice(-1) === '/') {
            ivOrigin = ivOrigin.slice(0, -1);
        }

        // polyfill for location.origin
        if (typeof location.origin === 'undefined') {
            location.origin = location.protocol + '//' + location.host;
        }

        // Message received and sender will be the same.
        if (ivOrigin.indexOf('/') === 0) {
            ivOrigin = location.origin;
        }

        // init messaging
        window.addEventListener('message', messageEvent);

        /*
         * Handle message events.
         *
         * Forwards from opener to FotoWare or returns from FotoWare to opener.
         */
        function messageEvent(message) {
            if (verifyInputMessage(message)) {
                // forward message -> to FotoWare
                iframe.contentWindow.postMessage(message.data, ivOrigin);
            } else {
                // reply to opener <- from FotoWare
                window.opener.postMessage(message.data, location.origin);
            }
        }

        function getCookie(name) {
            var value = "; " + document.cookie;
            var parts = value.split("; " + name + "=");
            if (parts.length == 2) return parts.pop().split(";").shift();
            return "";
        }

        /*
         * Verifies a message as input to FotoWare:
         * Check that message origin is from us and make sure the message data is a valid input command.
         */
        function verifyInputMessage(message) {
            return incomingCommands.indexOf(message.data) !== -1 && message.origin === location.origin;
        }

        /*
         * Helper method to get specific query parameter from querystring
         */
        function getQueryStringParameterByName(name) {
            const url = window.location.href;
            name = name.replace(/[\[\]]/g, '\\$&');
            const regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)');
            const results = regex.exec(url);

            if (!results) {
                return '';
            }

            if (!results[2]) {
                return '';
            }

            return decodeURIComponent(results[2].replace(/\+/g, ' '));
        }
    });

function ajax(url, successFunc, errFunc) {
    var xhttp;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200 && successFunc!=null) {
            successFunc(this);
        }
        if (this.readyState == 4 && this.status != 200) {
            errFunc(this);
        }
    };
    xhttp.open("GET", url, true);
    xhttp.send();
}

